#include <LiquidCrystal_I2C.h>      //LCD library
#include <IRremote.h>               //remote library
LiquidCrystal_I2C lcd(0x27, 16, 4); //LCD

// Remote

#define RECEIVER_PIN 2 // define the IR receiver pin
IRrecv receiver(RECEIVER_PIN); // create a receiver object of the IRrecv class
decode_results results; // create a results object of the decode_results class

//Pinagem

int pinoBuzzer = 3;
int pinoIR = 2;
int pinoVib = 7;
int pinoRLED = 10;
int pinoGLED = 11;
int pinoBLED = 12;
int pinAicu = A7;
int pinAAjuste = A0;
unsigned long key_value = 0;  
int playing = 0;
int bpm = 550;
int teto = 0;
int chao = 0;
int PulseSensorPurplePin = 1``;        // Pulse Sensor PURPLE WIRE connected to ANALOG PIN 0
int LED13 = 13;   //  The on-board Arduion LED
int Signal;                // holds the incoming raw data. Signal value can range from 0-1024
int Threshold = 550; //controlar no remoto            // Determine which Signal to "count as a beat", and which to ingore.


void setup() {
  pinMode (pinoBuzzer, OUTPUT); // buzzer
  pinMode (pinoIR, INPUT_PULLUP); // buzzer button
  pinMode (pinAicu, INPUT); // ICU analog interface
  pinMode (pinAAjuste, INPUT); // Potentiometer
  pinMode (pinoVib, OUTPUT);
  pinMode (pinoRLED, OUTPUT);
  pinMode (pinoBLED, OUTPUT); 
  pinMode (pinoGLED, OUTPUT); 
  lcd.init();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("Iniciado");
  receiver.enableIRIn(); // enable the receiver
  receiver.blink13(true); // enable blinking of the built-in LED when an IR signal is received
  
  Serial.begin(9600);
}

void loop ()
{
  //pulsesensor
   Signal = analogRead(PulseSensorPurplePin);  // Read the PulseSensor's value.
                                              // Assign this value to the "Signal" variable.

   Serial.println(Signal);                    // Send the Signal value to Serial Plotter.


   if(Signal > Threshold){                          // If the signal is above "550", then "turn-on" Arduino's on-Board LED.
     digitalWrite(pinoRLED,HIGH);
   } else {
     digitalWrite(pinoRLED,LOW);                //  Else, the sigal must be below "550", so "turn-off" this LED.
   }

  
  // InterComUnit
  // Sinais
  int sinalpuro = analogRead(pinAicu);
  int escala = analogRead(pinAAjuste);
  int sinalamplificado = map(sinalpuro, chao, teto, 200, 500);
  if (sinalpuro == 0) {
    noTone(pinoBuzzer);
  }
  int sinalLED = map(sinalpuro, chao, teto, 0, 255);

  //LCD
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("S:");
  lcd.print(sinalpuro, 1);
  lcd.print(",E:");
  lcd.print(escala);
  lcd.setCursor(0,1);
  lcd.print("A:");
  lcd.print(sinalamplificado);
  lcd.print(",P:");
  lcd.print(Signal, 1);

  //Play

if (playing == 1) {
  tone(pinoBuzzer, sinalamplificado);
  analogWrite(pinoBLED, random (0, sinalLED));
  digitalWrite(pinoVib, HIGH);
}


  // Buttons
if (receiver.decode(&results)) { // decode the received signal and store it in results
    if (results.value == 0xFFFFFFFF) { // if the value is equal to 0xFFFFFFFF
      results.value = key_value; // set the value to the key value
      //Serial.println (key_value);
    }
    switch (results.value) { // compare the value to the following cases
      case 0xF7C03F: // if the value is equal to 0xFD00FF
        //Serial.println("POWER"); // start music play
        if (playing == 0) {
          tone(pinoBuzzer, sinalamplificado);
          analogWrite(sinalamplificado, HIGH);
          playing = 1;
          //Serial.println(playing);
        }
        break;
      case 0xF740BF: // stop music play
        noTone(pinoBuzzer);
        digitalWrite(pinoBLED, LOW);
        digitalWrite(pinoVib, LOW);
        playing = 0;
        //Serial.println(notplaying);
        break;
      case 0xF7E01F: // delay escala
        bpm = escala;
        break;
      case 0xF700FF: // definir teto
        teto = escala;
        break;
      case 0xF7807F: // definir chao
        chao = escala;
        break;
    }
    key_value = results.value; // store the value as key_value
    receiver.resume(); // reset the receiver for the next code
  }

    //Debug

Serial.println(sinalpuro);
//Serial.println(escala);
//Serial.println(sinalamplificado);
//analogWrite(pinoGLED, random (0, sinalLED));
//analogWrite(pinoRLED, random (0, sinalLED));
//analogWrite(pinoBLED, random (0, sinalLED));

delay (bpm);
}
